package org.xcats.frc.deep_space.processors;

import org.xcats.frc.lib.logging.XLogString;
import org.xcats.frc.lib.processors.XProcessor;

import edu.wpi.first.wpilibj.Spark;

public abstract class BaseRevBlinkinDriver implements XProcessor {
	
	protected enum Patterns {
		RAINBOW_RAINBOW_PATTERN(-0.99),
		RAINBOW_PARTY_PATTERN(-0.97),
		RAINBOW_OCEAN_PATTERN(-0.95),
		RAINBOW_LAVA_PATTERN(-0.93),
		RAINBOW_FOREST_PATTERN(-0.91),
		RAINBOW_GLITTER_PATTERN(-0.89),
		CONFETTI_PATTERN(-0.87),
		SHOT_RED_PATTERN(-0.85),
		SHOT_BLUE_PATTERN(-0.83),
		SHOT_WHITE_PATTERN(-0.81),
		SINELON_RAINBOW_PATTERN(-0.79),
		SINELON_PARTY_PATTERN(-0.77),
		SINELON_OCEAN_PATTERN(-0.75),
		SINELON_LAVA_PATTERN(-0.73),
		SINELON_FOREST_PATTERN(-0.71),
		BEATS_PER_MINUTE_RAINBOW_PATTERN(-0.69),
		BEATS_PER_MINUTE_PARTY_PATTERN(-0.67),
		BEATS_PER_MINUTE_OCEAN_PATTERN(-0.65),
		BEATS_PER_MINUTE_LAVA_PATTERN(-0.63),
		BEATS_PER_MINUTE_FOREST_PATTERN(-0.61),
		FIRE_MEDIUM_PATTERN(-0.59),
		FIRE_LARGE_PATTERN(-0.57),
		TWINKLES_RAINBOW_PATTERN(-0.55),
		TWINKLES_PARTY_PATTERN(-0.53),
		TWINKLES_OCEANS_PATTERN(-0.51),
		TWINKLES_LAVA_PATTERN(-0.49),
		TWINKLES_FOREST_PATTERN(-0.47),
		COLOR_WAVES_RAINBOW_PATTERN(-0.45),
		COLOR_WAVES_PARTY_PATTERN(-0.43),
		COLOR_WAVES_OCEANS_PATTERN(-0.41),
		COLOR_WAVES_LAVA_PATTERN(-0.39),
		COLOR_WAVES_FOREST_PATTERN(-0.37),
		LARSON_SCANNER_RED_PATTERN(-0.35),
		LARSON_SCANNER_GREY_PATTERN(-0.33),
		LIGHT_CHASE_RED_PATTERN(-0.31),
		LIGHT_CHASE_BLUE_PATTERN(-0.29),
		LIGHT_CHASE_GREY_PATTERN(-0.27),
		HEARTBEAT_RED_PATTERN(-0.25),
		HEARTBEAT_BLUE_PATTERN(-0.23),
		HEARTBEAT_WHITE_PATTERN(-0.21),
		HEARTBEAT_GREY_PATTERN(-0.19),
		BREATH_RED_PATTERN(-0.17),
		BREATH_BLUE_PATTERN(-0.15),
		BREATH_GREY_PATTERN(-0.13),
		STROBE_RED_PATTERN(-0.11),
		STROBE_BLUE_PATTERN(-0.09),
		STROBE_GOLD_PATTERN(-0.07),
		STROBE_WHITE_PATTERN(-0.05),
		COLOR_1_END_TO_END_BLEND_PATTERN(-0.03),
		COLOR_1_LARSON_SCANNER_PATTERN(-0.01),
		COLOR_1_LIGHT_CHASE_PATTERN(0.01),
		COLOR_1_HEARTBEAT_SLOW_PATTERN(0.03),
		COLOR_1_HEARTBEAT_MEDIUM_PATTERN(0.05),
		COLOR_1_HEARTBEAT_FAST_PATTERN(0.07),
		COLOR_1_BREATH_SLOW_PATTERN(0.09),
		COLOR_1_BREATH_FAST_PATTERN(0.11),
		COLOR_1_SHOT_PATTERN(0.13),
		COLOR_1_STROBE_PATTERN(0.15),
		COLOR_2_END_TO_END_BLEND_PATTERN(0.17),
		COLOR_2_LARSON_SCANNER_PATTERN(0.19),
		COLOR_2_LIGHT_CHASE_PATTERN(0.21),
		COLOR_2_HEARTBEAT_SLOW_PATTERN(0.23),
		COLOR_2_HEARTBEAT_MEDIUM_PATTERN(0.25),
		COLOR_2_HEARTBEAT_FAST_PATTERN(0.27),
		COLOR_2_BREATH_SLOW_PATTERN(0.29),
		COLOR_2_BREATH_FAST_PATTERN(0.31),
		COLOR_2_SHOT_PATTERN(0.33),
		COLOR_2_STROBE_PATTERN(0.35),
		COLOR_1_AND_2_SPARKLE_1_ON_2_PATTERN(0.37),
		COLOR_1_AND_2_SPARKLE_2_ON_1_PATTERN(0.39),
		COLOR_1_AND_2_COLOR_GRADIENTPATTERN(0.41),
		COLOR_1_AND_2_BEATS_PER_MINUTE_PATTERN(0.43),
		COLOR_1_AND_2_END_TO_END_12_PATTERN(0.45),
		COLOR_1_AND_2_END_TO_END_PATTERN(0.47),
		COLOR_1_AND_2_COLOR_PATTERN(0.49),
		COLOR_1_AND_2_TWINKLES_PATTERN(0.51),
		COLOR_1_AND_2_COLOR_WAVES_PATTERN(0.53),
		COLOR_1_AND_2_SINELON_PATTERN(0.55),
		SOLID_HOT_PINK_PATTERN(0.57),
		SOLID_DARK_RED_PATTERN(0.59),
		SOLID_RED_PATTERN(0.61),
		SOLID_RED_ORANGE_PATTERN(0.63),
		SOLID_ORANGE_PATTERN(0.65),
		SOLID_GOLD_PATTERN(0.67),
		SOLID_YELLOW_PATTERN(0.69),
		SOLID_LAWN_GREEN_PATTERN(0.71),
		SOLID_LIME_PATTERN(0.73),
		SOLID_DARK_GREEN_PATTERN(0.75),
		SOLID_GREEN_PATTERN(0.77),
		SOLID_BLUE_GREEN_PATTERN(0.79),
		SOLID_AQUA_PATTERN(0.81),
		SOLID_SKY_BLUE_PATTERN(0.83),
		SOLID_DARK_BLUE_PATTERN(0.85),
		SOLID_BLUE_PATTERN(0.87),
		SOLID_BLUE_VIOLET_PATTERN(0.89),
		SOLID_VIOLET_PATTERN(0.91),
		SOLID_WHITE_PATTERN(0.93),
		SOLID_GREY_PATTERN(0.95),
		SOLID_DARK_GREY_PATTERN(0.97),
		SOLID_BLACK_PATTERN(0.99);
		
		private final double mSpeed;
		
		Patterns(double speed) {
			mSpeed = speed;
		}
	}
	


	private final Spark mSpark;
	protected Patterns mPattern;

	public BaseRevBlinkinDriver(Spark spark) {
		mSpark = spark;
		mPattern = Patterns.SOLID_BLACK_PATTERN;
	}

	@Override
	public XLogString getLogString() {
		return null;
	}

	@Override
	public void writePeriodicOutput() {
		if (mPattern != null) {
			mSpark.set(mPattern.mSpeed);
		}
	}

}
